#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "conway.h"

#define N			128
#define MAXITERS	10000

int main(void)
{
	// initialize board
	char **board, **board_new;
	srand(1573949136);
	board = board_initialize(N, N);
	board_new = board_initialize(N, N);
	board_print(board, N, N);

	// evolve
	int iters = 0;
	while (iters < MAXITERS)
	{
		for (int i = 0; i < N; i++)
			for (int j = 0; j < N; j++)
			{
				int neighs = count_neighbors(board, N, N, i, j);
				if (neighs == 3 || (board[i][j] == 1 && neighs == 2))
					board_new[i][j] = 1;
				else
					board_new[i][j] = 0;
			}

		iters++;
		board_update(&board, &board_new);
	}

	// print the result
	board_print(board, N, N);

	// free host memory
	board_free(board);
	board_free(board_new);

	return 0;
}
